//+------------------------------------------------------------------+
//|                                             BB_CCI_CrossOver.mq5 |
//|                            Copyright  2009, Daniel Vieira Costa |
//|                             http://www.seilatrader.blogspot.com/ |
//+------------------------------------------------------------------+
//----  
#property copyright "Copyright  2009, Daniel Vieira Costa"
//----    
#property link      "http://www.seilatrader.blogspot.com/"
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----        
#property indicator_buffers 2
//----     
#property indicator_plots   2
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//----   1   
#property indicator_type1   DRAW_ARROW
//----         
#property indicator_color1  clrMagenta
//----    1  4
#property indicator_width1  4
//----    
#property indicator_label1  "BB_CCI_CrossOver Sell"
//+----------------------------------------------+
//|            |
//+----------------------------------------------+
//----   2   
#property indicator_type2   DRAW_ARROW
//----         
#property indicator_color2  clrLime
//----    2  4
#property indicator_width2  4
//----    
#property indicator_label2 "BB_CCI_CrossOver Buy"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET  0 //        
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int    CCI_Period    = 21;
input double NivelCCI_MIN  = -80;
input double NivelCCI_MAX  = +80;
input int    MM_Period     = 14;
input int    BB_Period     = 21;
input double BB_Desvio     = 2.0;
input uint   PIP_DesvioMAX = 10;
input uint   PIP_DesvioMIN = 10;
//+----------------------------------------------+

//----   ,    
//      
double SellBuffer[];
double BuyBuffer[];
//---
double dPIP_DesvioMAX,dPIP_DesvioMIN;
int CCI_Handle,ATR_Handle,BB_Handle,min_rates_total;
//+------------------------------------------------------------------+
//   CMoving_Average                                   |
//+------------------------------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//----    
   min_rates_total=int(MathMax(MathMax(CCI_Period,BB_Period),10));
   dPIP_DesvioMAX=PIP_DesvioMAX*_Point;
   dPIP_DesvioMIN=PIP_DesvioMIN*_Point;
//----    CCI
   CCI_Handle=iCCI(NULL,0,CCI_Period,PRICE_WEIGHTED);
   if(ATR_Handle==INVALID_HANDLE)Print("      CCI");
//----    Bands
   BB_Handle=iBands(NULL,0,BB_Period,0,BB_Desvio,PRICE_WEIGHTED);
   if(ATR_Handle==INVALID_HANDLE)Print("      Bands");
//----    ATR
   ATR_Handle=iATR(NULL,0,10);
   if(ATR_Handle==INVALID_HANDLE)Print("      ATR");

//----      
   SetIndexBuffer(0,SellBuffer,INDICATOR_DATA);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(0,PLOT_ARROW,234);
//----       
   ArraySetAsSeries(SellBuffer,true);

//----      
   SetIndexBuffer(1,BuyBuffer,INDICATOR_DATA);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   
   PlotIndexSetInteger(1,PLOT_ARROW,233);
//----       
   ArraySetAsSeries(BuyBuffer,true);

//----     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//----         
   string short_name="BB_CCI_CrossOver";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//----   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//----       
   if(BarsCalculated(CCI_Handle)<rates_total
      || BarsCalculated(BB_Handle)<rates_total
      || BarsCalculated(ATR_Handle)<rates_total
      || rates_total<min_rates_total)
      return(RESET);

//----    
   int to_copy,limit,bar,maxbar;
   double range,MM,UpBB[],DnBB[],CCI[],ATR[];
   
   maxbar=rates_total-1-CCI_Period;

//----      
//  limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=maxbar; //      
     }
   else
     {
      limit=rates_total-prev_calculated; //      
     }

   to_copy=limit+1;

//----      
   if(CopyBuffer(CCI_Handle,0,0,to_copy,CCI)<=0) return(RESET);
   if(CopyBuffer(ATR_Handle,0,0,to_copy,ATR)<=0) return(RESET);
   if(CopyBuffer(BB_Handle,UPPER_BAND,0,to_copy,UpBB)<=0) return(RESET);
   if(CopyBuffer(BB_Handle,LOWER_BAND,0,to_copy,DnBB)<=0) return(RESET);

//----         
   ArraySetAsSeries(ATR,true);
   ArraySetAsSeries(CCI,true);
   ArraySetAsSeries(UpBB,true);
   ArraySetAsSeries(DnBB,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);

//----    CMoving_Average   SmoothAlgorithms.mqh 
   static CMoving_Average EMA;

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      range=ATR[bar]*3/8;
      MM=EMA.EMASeries(maxbar,prev_calculated,rates_total,MM_Period,CCI[bar],bar,true);

      BuyBuffer[bar]=0.0;
      SellBuffer[bar]=0.0;

      if(CCI[bar]>NivelCCI_MAX)
        {
         if(CCI[bar]<MM)
           {
            if(high[bar]<=UpBB[bar])
              {
               if(high[bar+1]>high[bar]) if(UpBB[bar]-high[bar]<=dPIP_DesvioMAX) SellBuffer[bar]=high[bar]+range;
              }
            else if(high[bar]>=UpBB[bar]) if(high[bar+1]>high[bar]) SellBuffer[bar]=high[bar]+range;
           }
        }

      if(CCI[bar]<NivelCCI_MIN)
        {
         if(CCI[bar]>MM)
           {
            if(low[bar]>=DnBB[bar])
              {
               if(low[bar+1]<low[bar]) if(low[bar]-DnBB[bar]<=dPIP_DesvioMIN) BuyBuffer[bar]=low[bar]-range;
              }
            else if(low[bar]<=DnBB[bar]) if(low[bar+1]<low[bar]) BuyBuffer[bar]=low[bar]-range;
           }
        }
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
